/* Processed by ecpg (2.8.0) */
/* These three include files are added by the preprocessor */
#include <ecpgtype.h>
#include <ecpglib.h>
#include <ecpgerrno.h>
#line 1 "acct.pgc"
/* hey emacs, this is C source code: -*-c-*-
 *
 * $Id: acct.pgc,v 1.2 2001/09/06 14:26:41 joergland Exp $
 *
 * Copyright (C) 1999-2001 Joerg Wendland <joerg@wendlandnet.de>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 * $Log: acct.pgc,v $
 * Revision 1.2  2001/09/06 14:26:41  joergland
 * imore fixes
 *
 * Revision 1.1  2001/09/06 11:17:41  joergland
 * tree reorg
 *
 * Revision 1.2  2001/04/01 19:30:33  joergland
 * auth and acct_mgmt works
 * some code-cleanup
 *
 *
 */

#define PAM_SM_ACCOUNT

#include "pam_pgsql.h"
#include "util.h"


#line 1 "/usr/include/postgresql/sqlca.h"
#ifndef POSTGRES_SQLCA_H
#define POSTGRES_SQLCA_H

#define SQLERRMC_LEN	70

#ifdef __cplusplus
extern		"C"
{
#endif

	struct sqlca
	{
		char		sqlcaid[8];
		long		sqlabc;
		long		sqlcode;
		struct
		{
			int			sqlerrml;
			char		sqlerrmc[SQLERRMC_LEN];
		}			sqlerrm;
		char		sqlerrp[8];
		long		sqlerrd[6];
		/* Element 0: empty						*/
		/* 1: OID of processed tuple if applicable			*/
		/* 2: number of rows processed				*/
		/* after an INSERT, UPDATE or				*/
		/* DELETE statement					*/
		/* 3: empty						*/
		/* 4: empty						*/
		/* 5: empty						*/
		char		sqlwarn[8];
		/* Element 0: set to 'W' if at least one other is 'W'	*/
		/* 1: if 'W' at least one character string		*/
		/* value was truncated when it was			*/
		/* stored into a host variable.				*/

		/*
		 * 2: if 'W' a (hopefully) non-fatal notice occured
		 *//* 3: empty */
		/* 4: empty						*/
		/* 5: empty						*/
		/* 6: empty						*/
		/* 7: empty						*/

		char		sqlext[8];
	};

	extern struct sqlca sqlca;


#ifdef __cplusplus
}

#endif

#endif

#line 39 "acct.pgc"


/*
 * somewhat senseless now since we do not have any account management yet
 */
PAM_EXTERN int 
pam_sm_acct_mgmt(pam_handle_t *pamh, 
		 int flags, 
		 int argc, 
		 const char **argv)
{
    int retval, len;

    /* exec sql begin declare section */
      
     
     
      
    
#line 1 "./globalopts.h"
  
    
    
    
    
    
    
    
    
    

#line 57 "acct.pgc"

    
#line 53 "acct.pgc"
  const char * uname   ;
 
#line 54 "acct.pgc"
   char * escuname   ;
 
#line 55 "acct.pgc"
   char * sqlstr   ;
 
#line 56 "acct.pgc"
   char  enabled   ,  valid   ;
 
#line 1 "./globalopts.h"
 extern  char * __db_url   , * __db_user   , * __db_password   , * __db_auth_table   , * __db_auth_login_field   , * __db_auth_passwd_field   , * __db_acct_table   , * __db_acct_login_field   , * __db_acct_enabled_field   , * __db_acct_pwdexpire_field   ;
/* exec sql end declare section */
#line 58 "acct.pgc"


    D("account management requested");
    
    /* get username from PAM */
    retval = pam_get_item(pamh, PAM_USER, (const void **)&uname);
    if(retval!=PAM_SUCCESS || uname==NULL) {	
	_pam_log(LOG_ERR, "could not get user name by pam_get_user()");
	return PAM_CONV_AGAIN;
    }

    D("got username");
    len = strlen(uname)*2+1;
    escuname = malloc(len);
    sqlescape(uname, escuname, len);

#ifndef _USE_PCONN

    /* connect to postgres */
    { ECPGconnect(__LINE__, __db_url , __db_user , __db_password , NULL, 0); }
#line 77 "acct.pgc"

    D("connected to database");

#endif /* _USE_PCONN */

    /* exec sql whenever sqlerror  sqlprint ; */

#line 82 "acct.pgc"


    /* create SQL string */
    asprintf(&sqlstr, 
	     "SELECT %s, ((%s is null) OR (%s>now())) as valid FROM %s WHERE %s='%s'", 
	     __db_acct_enabled_field, 
	     __db_acct_pwdexpire_field,
	     __db_acct_pwdexpire_field,
	     __db_acct_table, 
	     __db_acct_login_field, escuname);

    /* run query */
    { ECPGprepare(__LINE__, "acctsel", sqlstr);
#line 94 "acct.pgc"

if (sqlca.sqlcode < 0) sqlprint();}
#line 94 "acct.pgc"

    /* declare curs  cursor for ? */
#line 95 "acct.pgc"

    { ECPGdo(__LINE__, NULL, "declare curs  cursor for ?", 
	ECPGt_char_variable,(ECPGprepared_statement("acctsel")),1L,1L,1*sizeof(char), 
	ECPGt_NO_INDICATOR, NULL , 0L, 0L, 0L, ECPGt_EOIT, ECPGt_EORT);
#line 96 "acct.pgc"

if (sqlca.sqlcode < 0) sqlprint();}
#line 96 "acct.pgc"


    { ECPGdo(__LINE__, NULL, "fetch curs", ECPGt_EOIT, 
	ECPGt_char,&(enabled),1L,1L,1*sizeof(char), 
	ECPGt_NO_INDICATOR, NULL , 0L, 0L, 0L, 
	ECPGt_char,&(valid),1L,1L,1*sizeof(char), 
	ECPGt_NO_INDICATOR, NULL , 0L, 0L, 0L, ECPGt_EORT);
#line 98 "acct.pgc"

if (sqlca.sqlcode < 0) sqlprint();}
#line 98 "acct.pgc"


    retval = sqlca.sqlcode;
    /* close cursor */
    { ECPGdo(__LINE__, NULL, "close curs", ECPGt_EOIT, ECPGt_EORT);
#line 102 "acct.pgc"

if (sqlca.sqlcode < 0) sqlprint();}
#line 102 "acct.pgc"

    { ECPGtrans(__LINE__, NULL, "commit");
#line 103 "acct.pgc"

if (sqlca.sqlcode < 0) sqlprint();}
#line 103 "acct.pgc"


    free(sqlstr);
    free(escuname);
     
    /* records found? */
    if(retval == 0) {
	/* yep, check, if this user is allowed to access the system */
	if(enabled=='t' && valid=='t') {
	    retval = PAM_SUCCESS ;
	} else if(valid=='f') {
	    retval = PAM_NEW_AUTHTOK_REQD;
	} else if(enabled=='f') {
	    retval = PAM_ACCT_EXPIRED;
	} else {
	    _pam_log(LOG_ERR, "unknown error in acct.pgc, is your db inconsistent?");
	    retval = PAM_SYSTEM_ERR;
	}
    } else {
	retval = PAM_USER_UNKNOWN;
    }

    return retval; 
}
