/* Processed by ecpg (2.8.0) */
/* These three include files are added by the preprocessor */
#include <ecpgtype.h>
#include <ecpglib.h>
#include <ecpgerrno.h>
#line 1 "auth.pgc"
/* yo emacs, take this: -*-c-*-
 * 
 * $Id: auth.pgc,v 1.2 2001/09/06 12:07:44 joergland Exp $
 *
 * Copyright (C) 1999-2001 Joerg Wendland <joerg@wendlandnet.de>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 * $Log: auth.pgc,v $
 * Revision 1.2  2001/09/06 12:07:44  joergland
 * sql escape of user supplied data
 * fixed some memory leaks
 *
 * Revision 1.1  2001/09/06 11:17:41  joergland
 * tree reorg
 *
 * Revision 1.4  2001/04/08 20:32:17  joergland
 * changed call of conversation()
 *
 * Revision 1.3  2001/04/08 18:31:44  joergland
 * get username by pam_get_user rather then by pam_get_item
 *
 * Revision 1.2  2001/04/01 19:30:33  joergland
 * auth and acct_mgmt works
 * some code-cleanup
 *
 *
 */

#include "pam_pgsql.h"
#include "util.h"

#define PAM_SM_AUTH


#line 1 "/usr/include/postgresql/sqlca.h"
#ifndef POSTGRES_SQLCA_H
#define POSTGRES_SQLCA_H

#define SQLERRMC_LEN	70

#ifdef __cplusplus
extern		"C"
{
#endif

	struct sqlca
	{
		char		sqlcaid[8];
		long		sqlabc;
		long		sqlcode;
		struct
		{
			int			sqlerrml;
			char		sqlerrmc[SQLERRMC_LEN];
		}			sqlerrm;
		char		sqlerrp[8];
		long		sqlerrd[6];
		/* Element 0: empty						*/
		/* 1: OID of processed tuple if applicable			*/
		/* 2: number of rows processed				*/
		/* after an INSERT, UPDATE or				*/
		/* DELETE statement					*/
		/* 3: empty						*/
		/* 4: empty						*/
		/* 5: empty						*/
		char		sqlwarn[8];
		/* Element 0: set to 'W' if at least one other is 'W'	*/
		/* 1: if 'W' at least one character string		*/
		/* value was truncated when it was			*/
		/* stored into a host variable.				*/

		/*
		 * 2: if 'W' a (hopefully) non-fatal notice occured
		 *//* 3: empty */
		/* 4: empty						*/
		/* 5: empty						*/
		/* 6: empty						*/
		/* 7: empty						*/

		char		sqlext[8];
	};

	extern struct sqlca sqlca;


#ifdef __cplusplus
}

#endif

#endif

#line 46 "auth.pgc"


/*
 * handles authentication mechanism
 */
PAM_EXTERN int 
pam_sm_authenticate(pam_handle_t *pamh, 
		    int flags, 
		    int argc, 
		    const char **argv)
{
    int retval, len;
    char *passwd;
	
    /* exec sql begin declare section */
      
      
      
    
#line 1 "./globalopts.h"
  
    
    
    
    
    
    
    
    
    

#line 64 "auth.pgc"

    
#line 61 "auth.pgc"
   char * sqlstr   , * escuname   ;
 
#line 62 "auth.pgc"
  const char * uname   ;
 
#line 63 "auth.pgc"
  const char  dbpasswd [ 100 ]   ;
 
#line 1 "./globalopts.h"
 extern  char * __db_url   , * __db_user   , * __db_password   , * __db_auth_table   , * __db_auth_login_field   , * __db_auth_passwd_field   , * __db_acct_table   , * __db_acct_login_field   , * __db_acct_enabled_field   , * __db_acct_pwdexpire_field   ;
/* exec sql end declare section */
#line 65 "auth.pgc"


    D("authentication requested");

    /* get username from PAM */
    retval = pam_get_user(pamh, &uname, "Username: ");
    if(retval!=PAM_SUCCESS || uname==NULL) {	
	_pam_log(LOG_ERR, "could not get user name by pam_get_user()");
	return PAM_CONV_AGAIN;
    }
	
    D("got username");
    /* escape the username */
    len = strlen(uname)*2+1;
    escuname = malloc(len);
    sqlescape(uname, escuname, len);
    

    /* get password */
    retval = conversation(pamh, "Password: ");
    retval = pam_get_item(pamh, PAM_AUTHTOK, (const void **)&passwd);
    if(retval!=PAM_SUCCESS || passwd == NULL) {
	_pam_log(LOG_ERR, "could not get password for user %s", uname);
	return PAM_CONV_AGAIN;
    }
    pam_set_item(pamh, PAM_OLDAUTHTOK, passwd);
    D("got password");

    /* exec sql whenever sqlerror  sqlprint ; */

#line 93 "auth.pgc"


#ifndef _USE_PCONN

    /* connect to postgres */
    { ECPGconnect(__LINE__, __db_url , __db_user , __db_password , NULL, 0); 
#line 98 "auth.pgc"

if (sqlca.sqlcode < 0) sqlprint();}
#line 98 "auth.pgc"

    D("connected to database");

#endif /* _USE_PCONN */

	
    /* create SQL string */
    asprintf(&sqlstr, 
	     "SELECT %s FROM %s WHERE %s='%s'", 
	     __db_auth_passwd_field, __db_auth_table, 
	     __db_auth_login_field, escuname);

    /* run query */
    { ECPGprepare(__LINE__, "authsel", sqlstr);
#line 111 "auth.pgc"

if (sqlca.sqlcode < 0) sqlprint();}
#line 111 "auth.pgc"

    /* declare curs  cursor for ? */
#line 112 "auth.pgc"

    { ECPGdo(__LINE__, NULL, "declare curs  cursor for ?", 
	ECPGt_char_variable,(ECPGprepared_statement("authsel")),1L,1L,1*sizeof(char), 
	ECPGt_NO_INDICATOR, NULL , 0L, 0L, 0L, ECPGt_EOIT, ECPGt_EORT);
#line 113 "auth.pgc"

if (sqlca.sqlcode < 0) sqlprint();}
#line 113 "auth.pgc"


    { ECPGdo(__LINE__, NULL, "fetch curs", ECPGt_EOIT, 
	ECPGt_char,(dbpasswd),100L,1L,100*sizeof(char), 
	ECPGt_NO_INDICATOR, NULL , 0L, 0L, 0L, ECPGt_EORT);
#line 115 "auth.pgc"

if (sqlca.sqlcode < 0) sqlprint();}
#line 115 "auth.pgc"


    retval = sqlca.sqlcode;
    /* close cursor */
    { ECPGdo(__LINE__, NULL, "close curs", ECPGt_EOIT, ECPGt_EORT);
#line 119 "auth.pgc"

if (sqlca.sqlcode < 0) sqlprint();}
#line 119 "auth.pgc"

    { ECPGtrans(__LINE__, NULL, "commit");
#line 120 "auth.pgc"

if (sqlca.sqlcode < 0) sqlprint();}
#line 120 "auth.pgc"


    /* now give the system some memory back */
    free(sqlstr);
    free(escuname);
     
    /* records found? */
    if(retval == 0) {
#ifdef _USE_CRYPT
	/* yep, do crypt check */
	retval = vrfy_passwd(passwd, dbpasswd) ? PAM_SUCCESS : PAM_AUTH_ERR;
#else
	retval = mstrncmp(passwd, dbpasswd) ? PAM_AUTH_ERR : PAM_SUCCESS;
#endif
    } else {
	retval = PAM_AUTH_ERR;
    }

    return retval; 
}
