/* Processed by ecpg (2.8.0) */
/* These three include files are added by the preprocessor */
#include <ecpgtype.h>
#include <ecpglib.h>
#include <ecpgerrno.h>
#line 1 "chauth.pgc"
/* emacs, this is a C source code: -*-c-*-
 *
 * $Id: chauth.pgc,v 1.2 2001/09/06 12:07:44 joergland Exp $
 *
 * Copyright (C) 1999-2001 Joerg Wendland <joerg@wendlandnet.de>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 * $Log: chauth.pgc,v $
 * Revision 1.2  2001/09/06 12:07:44  joergland
 * sql escape of user supplied data
 * fixed some memory leaks
 *
 * Revision 1.1  2001/09/06 11:17:41  joergland
 * tree reorg
 *
 * Revision 1.5  2001/04/08 20:32:38  joergland
 * implemented, works basically
 *
 * Revision 1.4  2001/04/08 18:33:01  joergland
 * more changes to autoconf, removed original Makefile from repository
 *
 * Revision 1.3  2001/04/08 15:01:45  joergland
 * converted project to autoconf/automake/libtool
 *
 * Revision 1.2  2001/04/01 19:30:33  joergland
 * auth and acct_mgmt works
 * some code-cleanup
 *
 *
 */

#define PAM_SM_PASSWORD

#include "pam_pgsql.h"
#include "util.h"


#line 1 "/usr/include/postgresql/sqlca.h"
#ifndef POSTGRES_SQLCA_H
#define POSTGRES_SQLCA_H

#define SQLERRMC_LEN	70

#ifdef __cplusplus
extern		"C"
{
#endif

	struct sqlca
	{
		char		sqlcaid[8];
		long		sqlabc;
		long		sqlcode;
		struct
		{
			int			sqlerrml;
			char		sqlerrmc[SQLERRMC_LEN];
		}			sqlerrm;
		char		sqlerrp[8];
		long		sqlerrd[6];
		/* Element 0: empty						*/
		/* 1: OID of processed tuple if applicable			*/
		/* 2: number of rows processed				*/
		/* after an INSERT, UPDATE or				*/
		/* DELETE statement					*/
		/* 3: empty						*/
		/* 4: empty						*/
		/* 5: empty						*/
		char		sqlwarn[8];
		/* Element 0: set to 'W' if at least one other is 'W'	*/
		/* 1: if 'W' at least one character string		*/
		/* value was truncated when it was			*/
		/* stored into a host variable.				*/

		/*
		 * 2: if 'W' a (hopefully) non-fatal notice occured
		 *//* 3: empty */
		/* 4: empty						*/
		/* 5: empty						*/
		/* 6: empty						*/
		/* 7: empty						*/

		char		sqlext[8];
	};

	extern struct sqlca sqlca;


#ifdef __cplusplus
}

#endif

#endif

#line 49 "chauth.pgc"


/*
 * handles password management
 * not yet implemented
 */
PAM_EXTERN int pam_sm_chauthtok(pam_handle_t *pamh, int flags, int argc, const char **argv)
{
    char *oldpw, *newpw, *newpw1, *newpw2, *salt;
    const char *uname;
    char *escuname;
    int retval, len;

    /* exec sql begin declare section */
     
    
#line 1 "./globalopts.h"
  
    
    
    
    
    
    
    
    
    

#line 64 "chauth.pgc"

    
#line 63 "chauth.pgc"
   char * sqlstmt   ;
 
#line 1 "./globalopts.h"
 extern  char * __db_url   , * __db_user   , * __db_password   , * __db_auth_table   , * __db_auth_login_field   , * __db_auth_passwd_field   , * __db_acct_table   , * __db_acct_login_field   , * __db_acct_enabled_field   , * __db_acct_pwdexpire_field   ;
/* exec sql end declare section */
#line 65 "chauth.pgc"


    /* exec sql whenever sqlerror  sqlprint ; */

#line 67 "chauth.pgc"


#ifndef _USE_PCONN

    /* connect to postgres */
    { ECPGconnect(__LINE__, __db_url , __db_user , __db_password , NULL, 0); 
#line 72 "chauth.pgc"

if (sqlca.sqlcode < 0) sqlprint();}
#line 72 "chauth.pgc"


#endif /* _USE_PCONN */

    if((flags & PAM_PRELIM_CHECK) == PAM_PRELIM_CHECK)
	return PAM_SUCCESS;

    D("password management requested");
    if(pam_sm_authenticate(pamh, flags, argc, argv) != PAM_SUCCESS) 
	return PAM_AUTH_ERR;
    retval = pam_get_item(pamh, PAM_OLDAUTHTOK, (const void **)&oldpw);
    retval = pam_get_user(pamh, &uname, "Username: ");
    D(uname);

    len = strlen(uname)*2+1;
    escuname = malloc(len);
    sqlescape(uname, escuname, len);

    retval = conversation(pamh, "New password: ");
    retval = pam_get_item(pamh, PAM_AUTHTOK, (const void **)&newpw);
    mastrncpy(&newpw1, newpw);
  
    retval = conversation(pamh, "Retype password: ");
    retval = pam_get_item(pamh, PAM_AUTHTOK, (const void **)&newpw);
    mastrncpy(&newpw2, newpw);

    retval = PAM_SERVICE_ERR;
  
    if(!mstrncmp(newpw1, newpw2)) {
	D("passwords match");
	salt = malloc(15);
	strncpy(salt, "$1$", 3);
	salt[3] = '\0';
	strncat(salt, createsalt(8), 8);
	D(salt);
	asprintf(&sqlstmt,
		 "UPDATE %s SET %s='%s' WHERE %s='%s'",
		 __db_auth_table,
		 __db_auth_passwd_field,
		 crypt(newpw1, salt),
		 __db_auth_login_field,
		 escuname);
	D(sqlstmt);
	{ ECPGdo(__LINE__, NULL, "?", 
	ECPGt_char_variable,(sqlstmt),1L,1L,1*sizeof(char), 
	ECPGt_NO_INDICATOR, NULL , 0L, 0L, 0L, ECPGt_EOIT, ECPGt_EORT);
#line 115 "chauth.pgc"

if (sqlca.sqlcode < 0) sqlprint();}
#line 115 "chauth.pgc"

	{ ECPGtrans(__LINE__, NULL, "commit");
#line 116 "chauth.pgc"

if (sqlca.sqlcode < 0) sqlprint();}
#line 116 "chauth.pgc"

        free(salt);
	retval = PAM_SUCCESS;
    } else
	retval = PAM_AUTH_ERR;

    free(sqlstmt);
    free(newpw1);
    free(newpw2);
    free(escuname);
	
    return retval;
}

